function Calc(config) { 
	this.daysPerWeek = 5;
	this.monthsPerYear = 12;
	this.vat = 0.2;
	this.twelvePercent = 0.12;
	this.nineteenPercent = 0.19;
	this.threePercent = 0.03;
	this.thirteenPercent = 0.13;
	this.tenPercent = 0.1;
	this.c12 = 4895;
	this.c17 = 29161;
	this.c29 = 4895;
	this.c34 = 29161;
	this.c47 = 4895;
	this.c52 = 29161;
	this.c65 = 8500;
	this.e65 = 8500;

	this.monthlyContractValue = 0;
	this.monthlyTakeHome = 0;
	this.netAnnualInvoice = 0;
	this.takeHomePercentage = 0;
	this.percentageTaxPaid = 0;

	this.Reset(config);
}

Calc.prototype.Reset = function(config) { 
	this.vars = config || {
		hours : 8,
		weeks : 52,
		hourly : 0,
		daily : 0,
		calcHourly : true
	};

	this.monthlyContractValue = 0;
	this.monthlyTakeHome = 0;
	this.netAnnualInvoice = 0;
	this.takeHomePercentage = 0;
	this.percentageTaxPaid = 0;
	
	this.Subcalculate();
}

Calc.prototype.Round = function(num) {
	try { return Math.round((num + 0.00001) * 100) / 100; }
	catch (e) { return 0; }
}

Calc.prototype.HoursPerDay = function() {
	var h = parseFloat(this.vars.hours);
	if (h < 1) return 8;
	return h;
}

Calc.prototype.WeeksPerYear = function() { 
	var w = parseInt(this.vars.weeks);
	if (w < 1) return 52;
	return w;
}

Calc.prototype.C3 = function() { 
	try { return this.Round(this.vars.hourly); }
	catch (e) { return this.Round(0); } 
}

Calc.prototype.C4 = function() { 
	try { return this.Round(this.vars.daily); }
	catch (e) { return this.Round(0); }
}

Calc.prototype.HasAnyRate = function() { return ((this.C3 > 0) || (this.C4 > 0)); }

Calc.prototype.Subcalculate = function() { 
	var c8 = 0;

	if (this.vars.calcHourly) c8 = this.C3() * this.HoursPerDay() * this.daysPerWeek * this.WeeksPerYear();
	else c8 = this.C4() * this.daysPerWeek * this.WeeksPerYear();

	var d8 = c8 * this.vat;
	var e8 = d8 + c8;
	var c6 = c8 / this.monthsPerYear;
	var c10 = d8 - (e8 * this.twelvePercent);
	var c14 = (c8 + c10 - this.c12) * this.nineteenPercent;
	var g14 = c14;
	var c16 = c8 + c10 - this.c12 - c14;
	var c18 = c16 - this.c17;
	var c19 = (c18 / 2.0) * this.threePercent;
	var c20 = c19 * this.nineteenPercent;
	var g20 = c20;
	var c21 = c18 + c19 - c20;
	var c25 = c8;
	var d25 = c25 * this.vat;
	var e25 = d25 + c25;
	var c27 = d25 - (e25 * this.thirteenPercent);
	var c31 = (c25 + c27 - this.c29) * this.nineteenPercent;
	var g31 = c31;
	var c33 = c25 + c27 - this.c29 - c31;
	var c35 = c21;
	var c36 = c33 - this.c34 + c35;
	var c37 = (c36 / 2.0) * this.threePercent;
	var c38 = c37 * this.nineteenPercent;
	var g38 = c38;
	var c39 = c36 + c37 - c38;
	var c43 = c25;
	var d43 = c25 * this.vat;
	var e43 = d43 + c43;
	var c45 = d43 - (e43 * this.thirteenPercent);
	var c49 = (c43 + c45 - this.c47) * this.nineteenPercent;
	var g49 = c49;
	var c51 = c43 + c45 - this.c47 - c49;
	var c53 = c39;
	var c55 = c51 - this.c52 + c53;
	var c56 = (c55 / 2.0) * this.threePercent;
	var c57 = c56 * this.nineteenPercent;
	var g57 = c57;
	var c58 = c55 + c56 - c57;
	var e64 = c58;
	var e67 = (e64 - this.e65) * this.tenPercent;
	var g67 = (e67 > 0) ? e67 : 0;
	var e68 = e64 - g67;
	var h72 = g14 + g20 + g31 + g38 + g49 + g57 + g67;
	var g74 = c8 + c25 + c43;
	var g75 = 0;
	var g76 = 0 + c10 + c27 + c45;
	var g77 = 0 + c56 + c37 + c19;
	var h79 = g74 + g75 + g76 + g77;
	var h81 = e68 + this.c47 + this.c52 + this.c29 + this.c34 + this.c12 + this.c17;
	var h83 = h72 / h79;
	var h85 = h81 / ( 3 * this.monthsPerYear);
	var h86 = h81 / h79;

	this.monthlyContractValue = c6;
	this.monthlyTakeHome = h85;
	this.netAnnualInvoice = c8;
	this.takeHomePercentage = this.Round(h86 * 100);
	this.percentageTaxPaid = this.Round(h83 * 100);

}